@border-color: #b8b8b8;

.absolute (@top: 0px, @right: 0px, @bottom: 0px, @left: 0px) {
    position: absolute;
    top: @top;
    right: @right;
    bottom: @bottom;
    left: @left;
}

.codeeditor {
  margin: 0px;
  padding: 0px;

  #execute {
    min-width: 100px;
  }
  #abort {
    margin-right: -1px;
    min-width: 100px;
  }

  #command-line {
    font-family: Menlo, Monaco, Consolas, "Courier New", monospace;
  }
}

.codeeditor-left {
  .absolute(@right: none);
  width: 100%;
  overflow: auto;
  border: 1px solid @border-color;
  border-width: 0px 1px 0px 0px;
}

.codeeditor-right {
  .absolute(@left: none);
  width: 0%;
  overflow: auto;
  padding-left: 1px;
}

.codeeditor-right-top {
  .absolute(@bottom: none);
  height: 100%;
  overflow: hidden;
  box-shadow: 0px 1px 0px @border-color;
}

.codeeditor-right-bottom {
  .absolute(@top: none);
  height: 0%;
  overflow: auto;
  padding: 11px 10px 10px 10px;
}

.codeeditor-commandline > * {
  border-radius: 0px;
}

.codeeditor-commandline > .input-group-addon {
  border-left: 0px;
}

.codeeditor-commandline button {
  border-radius: 0px;
}


.codeeditor-ace {
  .absolute() !important;
}

.codeeditor-output {
  .absolute(@top: 35px) !important;
  border-radius: 0px;
  margin: 0px 0px 0px 1px;
  border: 0px;
}

.codeeditor-output-buttons {
  position: absolute;
  top: 45px;
  right: 10px;
}

.codeeditor-right-top pre {
  overflow: auto;
}

.codeeditor-right-bottom .well {
  .absolute(@top: 55px, @right: 10px, @bottom: 10px, @left: 10px);
  padding: 10px;
  margin: 0px;
  white-space: nowrap;
  overflow-x: auto;
  overflow-y: auto;
}

.codeeditor-right-bottom .codeeditor-preview {
  position: relative;
  display: inline-block;
  margin: 0px 10px 10px 0px;
  padding: 6px;
  border-radius: 3px;
  border: 1px solid @border-color;
  background-color: white;
  float: left;
  overflow: hidden;
  > a {
    cursor: pointer;
  }
}

.codeeditor-right-bottom .codeeditor-preview:hover {
  border-color: #428bca;
}

.codeeditor-right-bottom .codeeditor-preview-label {
  position: absolute;
  top: 0px;
  right: 0px;
  left: 0px;
  height: 24px;
  text-align: center;
}

.codeeditor-right-bottom .codeeditor-preview-img {
  position: absolute;
  top: 24px;
  right: 0px;
  bottom: 0px;
  left: 0px;
  text-align: center;
}


.codeeditor-right-bottom .codeeditor-preview img {
  padding-top: 24px;
  height: 100px;
  width: auto;
}

.codeeditor-ace div.ace_scrollbar {
  overflow-x: auto !important;
  overflow-y: auto !important;
}

.codeeditor-x-dragbar {
  position: absolute;
  top: 0px;
  bottom: 0px;
  width: 4px;
  overflow: visible;
  z-index: 1;
  background-color: #E8E8E8;
  cursor: ew-resize;
}

.codeeditor-y-dragbar {
  position: absolute;
  left: 0px;
  right: 0px;
  height: 4px;
  overflow: visible;
  z-index: 1;
  background-color: #E8E8E8;
  cursor: ns-resize;
}
